From 94cce00fddbc7dd5617872730ae8eb1d2fbdfaf6 Mon Sep 17 00:00:00 2001
From: David Tolnay <dtolnay@gmail.com>
Date: May 11 2020 06:19:39 +0000
Subject: [PATCH 600/2232] Detect mismatched suffix on discriminant values


---

diff --git a/syntax/discriminant.rs b/syntax/discriminant.rs
index 4caa42b..d683eef 100644
--- a/syntax/discriminant.rs
+++ b/syntax/discriminant.rs
@@ -30,7 +30,14 @@ impl DiscriminantSet {
 
     pub fn insert(&mut self, expr: &Expr) -> Result<Discriminant> {
         let (discriminant, repr) = expr_to_discriminant(expr)?;
-        self.repr = self.repr.or(repr);
+        match (self.repr, repr) {
+            (None, _) => self.repr = repr,
+            (Some(prev), Some(repr)) if prev != repr => {
+                let msg = format!("expected {}, found {}", prev, repr);
+                return Err(Error::new(Span::call_site(), msg));
+            }
+            _ => {}
+        }
         insert(self, discriminant)
     }
 

